package de.kif.backend.util

object Search {
    private fun permute(list: List<String>): List<List<String>> {
        if (list.size <= 1) return listOf(list)

        val perm = mutableListOf<List<String>>()

        for (elem in list) {
            val p = permute(list - elem)

            for (x in p) {
                perm += x + elem
            }
        }

        return perm
    }

    fun match(search: String, vararg params: String): Boolean {
        val s = search.toLowerCase().replace(" ", "")

        return permute(params.map { it.toLowerCase().replace(" ", "") }).any {
            it.joinToString("").contains(s)
        }
    }

    fun pack(vararg params: String): String = params.joinToString("|") { it.toLowerCase() }
}
